#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008 <helderfraga@gmail.com>
#
# Consolidated Gnome Menu
# This is free software made available under the GNU public license.
# Use 'run-in-window' command switch for development testing

import sys
#Set the main module directory
try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'

sys.path.append(INSTALL_PREFIX + '/lib/gnomenu/')
#import pygtk
#pygtk.require('2.0')
import gtk
#import gtk.glade
import dbus
import dbus.service
if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
	if getattr(dbus, 'version', (0,0,0)) <= (0,80,0):
		
		import dbus.glib
	else:
		
		from dbus.mainloop.glib import DBusGMainLoop
		DBusGMainLoop(set_as_default=True)
import gnomeapplet
import sys
from Panel_Object import GnoMenu
import gobject
#from Cairo_Button_Window import CairoButtonWindow
gobject.type_register(GnoMenu)


# DBus Activation Class
class ActivateMenu(dbus.service.Object):
	def __init__(self, object_path):
		dbus.service.Object.__init__(self, dbus.SessionBus(), object_path)

	@dbus.service.signal(dbus_interface='org.GnoMenu.gnomenu', signature='')
	def GnoMenuActivate(self):
		pass
    


# Bonobo factory of Menu
def GnoMenu_factory(applet, iid):
    # Start the applet
    GnoMenu(applet,iid)
    return True


if len(sys.argv) == 2 and sys.argv[1] == "--help":
    print "HELP==============================="
    print "Command:          What it does:"
    print "show-menu         opens start menu"
    print "run-in-window     runs independant of gnome-panel"
    print "==================================="
    sys.exit ()
    
if len(sys.argv) == 2 and sys.argv[1] == "show-menu":
	event = ActivateMenu('/menu_activate_key')
	event.GnoMenuActivate()
    
if len(sys.argv) == 2 and sys.argv[1] == "run-in-window":
    # Start the applet in windowed mode
    main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    main_window.set_decorated(1)
    main_window.set_title("GnoMenu Testing Sandpit")
    main_window.connect("destroy", gtk.main_quit) 
    app = gnomeapplet.Applet()
    GnoMenu(app, None)
    app.reparent(main_window)
    main_window.show_all()
    gtk.main()
    sys.exit()
    
if __name__ == '__main__':
	gnomeapplet.bonobo_factory("OAFIID:GNOME_GnoMenu_Factory", 
                                     GnoMenu.__gtype__, 
                                     "@PACKAGE@", "@VERSION@", GnoMenu_factory)

